Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 155428 - kernel dm-multipath: Improve error logging
Summary: kernel dm-multipath: Improve error logging
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: device-mapper-multipath
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Lars Marowsky-Bree
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: MPIOU3Proposed 171408
TreeView+ depends on / blocked
 
Reported: 2005-04-20 09:09 UTC by Lars Marowsky-Bree
Modified: 2013-02-08 11:45 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed:


Attachments (Terms of Use)
Suggested patch to improve the logging situation (deleted)
2005-04-20 09:09 UTC, Lars Marowsky-Bree
no flags Details | Diff
Updated patch (deleted)
2005-04-21 10:44 UTC, Lars Marowsky-Bree
no flags Details | Diff

Description Lars Marowsky-Bree 2005-04-20 09:09:18 UTC
Device Mapper has a slight communication problem if accidentially misconfigured,
or if something goes wrong. It tends to silently throw an error upwards, or even
report gems such as "Unknown error".

The attached patch is a first step towards actually logging what went wrong and
providing more information in the logs.

Comment 1 Lars Marowsky-Bree 2005-04-20 09:09:18 UTC
Created attachment 113397 [details]
Suggested patch to improve the logging situation

Comment 2 Lars Marowsky-Bree 2005-04-21 10:44:24 UTC
Created attachment 113462 [details]
Updated patch

Do not try to print pgpath->path.dev->name when pgpath == NULL. Smart idea, eh?
;)

Comment 3 Alasdair Kergon 2005-04-21 19:07:19 UTC
I'll add this to 2.6.12-rc2-udm1 for now, but we need to tidy it more before
sending it upstream.

e.g. DMWARN("dm-emc: emc_endio: pg_init error %d", error);
     DMWARN("dm-emc: emc_endio: Found valid sense data %06x", sense);
     DMWARN("dm-emc: emc_endio: Array Based Copy in progress");

could fit into a single line:
   maybe "dm-emc: emc_endio: pg_init error %d (sense %06x): Array-based copy in
progress"


Comment 4 Lars Marowsky-Bree 2005-04-21 19:44:18 UTC
Good point. Yes, this needs more cleaning up and in particular also:

a) Rate-limitting; right now it'll trigger once for every bio, even though they
are part of the same SCSI request; if they could be joined well, that could be
quite substantial amounts of logging and quite flood the console. It'd be
interesting if we could figure out a way to only print it _once_ for every
request (ie, once for every real error).

(w/o keeping a complete history, we could try and only print it if this bio
belonged to a different request than the last bio we handled; that'll still
cause some excessive logging, but only if end_io is interleaved, which will be
much better already.)

Question is how to do figure out which request a bio belongs to. Another
alternative might be to only print if it's a new error on the same path or if
the last error on that path has been reported NNN jiffies back.

Comments solicited, maybe we want to discuss on the list too.

b) Identify more "interesting" places where to log from a support perspective:
What information will we need to track down problems in the field?




Note You need to log in before you can comment on or make changes to this bug.